/*
   Copyright (C) 1988, 1989, 1990 The GAP Development Company

   All Rights Reserved
   
   This source code is considered to be confidential information proprietary
   to The GAP Development Company.  It is prohibited and punishable by law
   to use or duplicate any part of this information without express
   written consent from GAP Development Company.

   This source code is being provided for informational purposes only.


   UTILIST.C

   UTI module that lists the available Forums.


   To compile : cl /FPa utilist.c        (will compile and link)

*/


#define LINT_ARGS

#define MULTIUSER
//#define SINGLEUSER

#pragma check_stack(off)
#pragma pack(1)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#include <share.h>


   char hismail    [60];
   char dflt_path  [60];                  // path to GAP default dir     


   struct FORUM
      {
      char name         [21];             // forum name                   
      char directory    [31];             // forum dir path               
      char gen_dir      [31];             // forum gen dir path           
      char up_dir       [31];             // upload dir path              
      char private_up    [2];             // keep uploads private?        
      char keep_up       [2];             // keep uploads in forum?       
      char auto_join     [2];             // auto rejoin forum?           
      char handle        [2];             // allow handles?               
      char priv_mail     [2];             // make all mail private?       
      char pub_mail      [2];             // make all mail public?        
      char subscrip      [9];             // expired subscrip date        
      char net_mail      [2];             // is this a netmail forum?     
      char sysop1       [31];             // # 1 sysop this forum         
      char sysop2       [31];             // # 2 sysop this forum         
      char main_dirs     [2];             // include main board dirs?     
      int bullets;                        // number of bulletins          
      int dirs;                           // number of directories        
      int security;                       // additional security          
      int time;                           // additional time              
      int sys1_level;                     // level for sysop 1            
      int sys2_level;                     // level for sysop 2            
      } forum;                            // 213 bytes                    

   /**********************************************************************/
   /* A shortened version of GAPBBS.CNF.  All we need is the path to the  /
   /* main directory.                                                     /
   /**********************************************************************/

   struct CONFIG
      {
      char sysname       [16];            // sysop name                   
      char syspas        [13];            // sysop local password         
      int sys_read;                       // level to read private mail   
      int sys_edit;                       // level to edit msg headers    
      int overwrite;                      // level to overwrite uploads   
      int sys_level1;                     // level to view callers log    
      int sys_level2;                     // level to view users          
      int sys_level3;                     // level to view a file         
      int sys_level4;                     // level to maintain user file  
      int sys_level5;                     // level to exit to dos         
      int sys_level5a;                    // level to execute dos funcs   
      int sys_level6;                     // level to view other nodes    
      int sys_level6a;                    // level to log off other node  
      int sys_level7;                     // level to recover messages    

      char answer         [8];            // questionnaire answers file   
      char caller         [7];            // caller file                  
      char doors          [9];            // doors.dat file               
      char forumdat       [9];            // name of forum (.DAT) file    
      char entry_news     [8];            // news file                    
      char exit_news      [8];            // exit news file               
      char pwrd           [9];            // time / security file         
      char fsec           [9];            // files security file          
      char msgs           [9];            // messages file                
      char new_welcome    [8];            // new user welcome file        
      char answer_regis   [8];            // not used                     
      char remote         [9];            // remote.sys file              
      char tcan           [9];            // trashcan file                
      char users          [9];            // users file                   
      char welcome        [8];            // welcome file                 

      char uploads        [26];           // upload directory             
      char gen            [26];           // general directory            
      char maindir        [26];           // main directory               
      char help           [26];           // help directory               
      char loose_dir      [26];           // directory where loose files are

      char dumb_modem      [2];           // use true ring detect?        
      char modem_init     [45];           // initilization string         
      char modem_off      [45];           // off hook string              
      int  modem_wait;                    // seconds to wait for carrier  
      int  connect_wait;                  // seconds to wait for connect  
      char modem_reset    [45];           // reset string                 
      char port            [2];           // com port                     
      char speed           [6];           // speed to open modem at       
      char baud_300        [2];           // restrict Baud rates?         
      char baud_start      [6];           // restrict start time          
      char baud_end        [6];           // restrict end time            
      char baud_rest      [10];           // highest baud rate to restrict
      char lock_baud       [2];           // lock in the baud rate        
      char zstream         [2];           // full flow zmodem uploads     

      int menuA;                          //  main menu security levels   
      int menuB;
      int menuC;
      int menuD;
      int menuE;
      int menuF;
      int menuG;
      int menuH;
      int menuI;
      int menuJ;
      int menuK;
      int menuL;
      int menuM;
      int menuN;
      int menuO;
      int menuP;
      int menuQ;
      int menuR;
      int menuS;
      int menuT;
      int menuU;
      int menuV;
      int menuW;
      int menuX;
      int menuY;
      int menuZ;

      int menu_chat;                     // chat with other nodes        
      int menu_open;                     // open a door                  
      int menu_who;                      // who's on other nodes         
      int regis;                         // registration level           
      int year_regis;                    // level for subscrip expired   

      int viewG;                         //  view/change stats           
      int viewN;              
      int viewL;              
      int viewT;             
      int viewX;              

      int fileA;                         //  file menu security levels   
      int fileB;                         // browse text files            
      int fileC;
      int fileD;
      int fileE;
      int fileF;                         //  file menu security levels   
      int fileG;
      int fileH;
      int fileI;
      int fileJ;
      int fileK;
      int fileL;
      int fileM;
      int fileN;
      int fileO;
      int fileP;
      int fileQ;
      int fileR;
      int fileS;
      int fileT;
      int fileU;
      int fileV;
      int fileW;
      int fileX;
      int fileY;
      int fileZ;

      int blts;                           // number of main bulletins     
      int cnfs;                           // number of FORUMS             
      }config;


   static int pascal open_gapcnf(void );
   static char *trim(char *str);
   static int pascal read_forumdat(void );


void main(argc,argv)
int argc;
char *argv[];
{
   int error = 0;

   strcpy(hismail,argv[1]);               // path to HIGHNUM.TXT     

   if ( (error = open_gapcnf()) != 0)
      exit (error);

   error = read_forumdat();

   exit(error);
}

static int pascal open_gapcnf()           // get path to GAP main dir 
{
   int gapfile;

   FILE *fp;

   if ( (fp = fopen("GAPUTI.CNF","rt")) == NULL)
      return (errno);

   fscanf(fp,"%s",dflt_path);             // path to GAP default directory     
   fclose(fp);

   strcat(dflt_path,"\\GAPBBS.CNF");

#ifdef MULTIUSER
   gapfile = sopen(dflt_path,O_RDONLY | O_BINARY,SH_DENYNO);
#else
   gapfile = open(dflt_path,O_RDONLY | O_BINARY);
#endif

   if(gapfile == -1)
      return (errno);

   read(gapfile,(char *) &config,sizeof(config));
   close(gapfile);

   trim(config.maindir);
   trim(config.forumdat);

   return (0);
}

static char *trim(str)
char *str;
{
   char *ptr;
   
   ptr = str + strlen(str) -1;
  
   while(ptr >= str && *ptr == ' ')
      *ptr-- = 0;

   return(str);
}

static int pascal read_forumdat()
{
   register int r;
   int forumfile;
   char forumpath [60];

   FILE *fp;

   sprintf(forumpath,"%s\\%s.DAT",config.maindir,config.forumdat);

#ifdef MULTIUSER
   forumfile = sopen(forumpath, O_RDONLY | O_BINARY,SH_DENYNO);
#else
   forumfile = open(forumpath, O_RDONLY | O_BINARY);
#endif

   if (forumfile == -1)                   // cant open file            
      return (errno);

   if ( (fp = fopen(hismail,"w+t")) == NULL)
      {
      close(forumfile);
      return (-1);
      }
 
   fprintf(fp,"0\nMAIN\nMain Board\n");

   for (r = 1; r <= config.cnfs; r++)
      {
      read(forumfile,(char *) &forum,sizeof(forum));
      trim(forum.name);
      forum.name[15] = 0;                 // UTI spec only supports 15 chars
      fprintf(fp,"%d\n%s\n\n",r,forum.name);
      }

   close(forumfile);
   fclose(fp);
   return(0);
}
